#include <msp430.h>

void SRAMWrite(int size, char data);
void SRAMVerify(int size, char data);

unsigned int count = 0;
unsigned int error = 0;
unsigned char *SRAM_write_ptr;
unsigned char write_data;

#define SRAM1_TEST_START 0x2082  // SRAM1 is 0x2082~0x3540

#define SRAM1_SIZE 0x14BF

#define FRAM1_SIZE 0x14BF
#pragma PERSISTENT(FRAM_BUF)
unsigned char FRAM_BUF[FRAM1_SIZE] = { 0 };


int main(void)
{
    WDTCTL = WDTPW | WDTHOLD;               // Stop watchdog timer

    P1OUT &= ~BIT0;                         // Clear P1.0 output latch for a defined power-on state
    P1DIR |= BIT0;                          // Set P1.0 to output directionOUT

    PM5CTL0 &= ~LOCKLPM5;                   // Disable the GPIO power-on default high-impedance mode
                                            // to activate previously configured port settings
    write_data = 0xFF;
    while(1)
    {

        SRAM_write_ptr = (unsigned char *)SRAM1_TEST_START;
        SRAMWrite(SRAM1_SIZE, write_data);
        SRAM_write_ptr = (unsigned char *)SRAM1_TEST_START;
        SRAMVerify(SRAM1_SIZE, write_data);

        write_data++;
        count++;
    }
}

void SRAMWrite (int size, char data)
{
    unsigned int i=0;

    for (i = 0; i < size; i++)
    {
        *SRAM_write_ptr++ = data;
    }
}

void SRAMVerify (int size, char data)
{
    unsigned int i=0;

    for (i = 0; i < size; i++)
    {
        FRAM_BUF[i] =  *SRAM_write_ptr;
        if(*SRAM_write_ptr++ != data)
        {
            error++;
            P1OUT = BIT0;
        }

    }
}
